From 10dfa622b09c420d79da8774c9321f91540c8600 Mon Sep 17 00:00:00 2001
From: Boris Mironov <boris.mironov@gmail.com>
Date: Mon, 16 Feb 2026 09:08:17 +0700
Subject: [PATCH v9 19/26] Small changes due to big code review

---
 src/bin/pgbench/pgbench.c | 71 +++++++++++++++++++++------------------
 1 file changed, 39 insertions(+), 32 deletions(-)

diff --git a/src/bin/pgbench/pgbench.c b/src/bin/pgbench/pgbench.c
index 34464b7037c..9f3d7f99a25 100644
--- a/src/bin/pgbench/pgbench.c
+++ b/src/bin/pgbench/pgbench.c
@@ -873,7 +873,7 @@ static bool socket_has_input(socket_set *sa, int fd, int idx);
 
 /* callback used to build rows for COPY during data loading */
 typedef void (*initRowMethod)		(PQExpBufferData *sql, int64 curr);
-typedef void (*initRowMethodBin)	(PGconn *con, int64_t curr, int32_t parent);
+typedef void (*initRowMethodBinary)	(PGconn *con, int64_t curr, int32_t parent, int8_t columnCounter);
 
 /* callback functions for our flex lexer */
 static const PsqlScanCallbacks pgbench_callbacks = {
@@ -942,7 +942,8 @@ usage(void)
 		   "                           to generate data, server-side:\n"
 		   "                             G:   INSERT .. SELECT generate_series\n"
 		   "                             U:   INSERT .. SELECT unnest\n"
-		   "                           M: use multiple transactions to initialize data\n"
+		   "                           S: flag to use single transaction to initialize data\n"
+		   "                           M: flag to use multiple transactions to initialize data\n"
 		   "                           v: invoke VACUUM on the standard tables\n"
 		   "                           p: create primary key indexes on the standard tables\n"
 		   "                           f: create foreign keys between the standard tables\n"
@@ -5053,8 +5054,8 @@ initAccount(PQExpBufferData *sql, int64 curr)
 }
 
 static void
-initPopulateTableText(PGconn *con, const char *table, int64 base,
-					  initRowMethod init_row)
+initPopulateTableCopyText(PGconn *con, const char *table, int64 base,
+						  initRowMethod init_row)
 {
 	int			n;
 	int64		k;
@@ -5178,7 +5179,7 @@ initPopulateTableText(PGconn *con, const char *table, int64 base,
  * a blank-padded string in pgbench_accounts.
  */
 static void
-initGenerateDataClientSideText(PGconn *con)
+initGenerateDataClientSideTextFrmt(PGconn *con)
 {
 	fprintf(stderr, "TEXT mode...\n");
 
@@ -5198,9 +5199,9 @@ initGenerateDataClientSideText(PGconn *con)
 	 * fill branches, tellers, accounts in that order in case foreign keys
 	 * already exist
 	 */
-	initPopulateTableText(con, "pgbench_branches", nbranches, initBranch);
-	initPopulateTableText(con, "pgbench_tellers",  ntellers,  initTeller);
-	initPopulateTableText(con, "pgbench_accounts", naccounts, initAccount);
+	initPopulateTableCopyText(con, "pgbench_branches", nbranches, initBranch);
+	initPopulateTableCopyText(con, "pgbench_tellers",  ntellers,  initTeller);
+	initPopulateTableCopyText(con, "pgbench_accounts", naccounts, initAccount);
 
 	executeStatement(con, "commit");
 }
@@ -5212,6 +5213,8 @@ initGenerateDataClientSideText(PGconn *con)
 static void
 bufferCharData(char *src, int32_t len)
 {
+	Assert(bin_copy_buffer_length + len <= BIN_COPY_BUF_SIZE);
+
 	memcpy((char *) bin_copy_buffer + bin_copy_buffer_length, (char *) src, len);
 	bin_copy_buffer_length += len;
 }
@@ -5227,13 +5230,16 @@ bufferData(void *src, int32_t len)
 	bufferCharData(src, len);
 #else
 	if (len == 1)
+	{
 		bufferCharData(src, len);
-	else
-		for (int32_t i = 0; i < len; i++)
-		{
-			((char *) bin_copy_buffer + bin_copy_buffer_length)[i] =
-				((char *) src)[len - i - 1];
-		}
+		return;
+	}
+
+	for (int32_t i = 0; i < len; i++)
+	{
+		((char *) bin_copy_buffer + bin_copy_buffer_length)[i] =
+			((char *) src)[len - i - 1];
+	}
 
 	bin_copy_buffer_length += len;
 #endif
@@ -5322,7 +5328,7 @@ flushBuffer(PGconn *con, int16_t row_len)
  * Sends current branch row to buffer
  */
 static void
-initBranchBinary(PGconn *con, int64_t curr, int32_t parent)
+initBranchBinary(PGconn *con, int64_t curr, int32_t parent, int8_t columnCounter)
 {
 	/*
 	 * Each row of branch table has following extra bytes:
@@ -5333,7 +5339,7 @@ initBranchBinary(PGconn *con, int64_t curr, int32_t parent)
 
 	flushBuffer(con, max_row_len);
 
-	addColumnCounter(2);
+	addColumnCounter(columnCounter);
 
 	addInt32Column(curr + 1);
 	addInt32Column(0);
@@ -5343,7 +5349,7 @@ initBranchBinary(PGconn *con, int64_t curr, int32_t parent)
  * Sends current teller row to buffer
  */
 static void
-initTellerBinary(PGconn *con, int64_t curr, int32_t parent)
+initTellerBinary(PGconn *con, int64_t curr, int32_t parent, int8_t columnCounter)
 {
 	/*
 	 * Each row of tellers table has following extra bytes:
@@ -5354,7 +5360,7 @@ initTellerBinary(PGconn *con, int64_t curr, int32_t parent)
 
 	flushBuffer(con, max_row_len);
 
-	addColumnCounter(3);
+	addColumnCounter(columnCounter);
 
 	addInt32Column(curr + 1);
 	addInt32Column(curr / parent + 1);
@@ -5365,7 +5371,7 @@ initTellerBinary(PGconn *con, int64_t curr, int32_t parent)
  * Sends current account row to buffer
  */
 static void
-initAccountBinary(PGconn *con, int64_t curr, int32_t parent)
+initAccountBinary(PGconn *con, int64_t curr, int32_t parent, int8_t columnCounter)
 {
 	/*
 	 * Each row of accounts table has following extra bytes:
@@ -5376,7 +5382,7 @@ initAccountBinary(PGconn *con, int64_t curr, int32_t parent)
 
 	flushBuffer(con, max_row_len);
 
-	addColumnCounter(3);
+	addColumnCounter(columnCounter);
 
 	if (scale <= SCALE_32BIT_THRESHOLD)
 		addInt32Column(curr + 1);
@@ -5391,8 +5397,9 @@ initAccountBinary(PGconn *con, int64_t curr, int32_t parent)
  * Universal wrapper for sending data in binary format
  */
 static void
-initPopulateTableBinary(PGconn *con, char *table, char *columns,
-						int counter, int64_t base, initRowMethodBin init_row)
+initPopulateTableCopyBinary(PGconn *con, char *table, char *columns,
+							int counter, int64_t base, initRowMethodBinary init_row,
+							int columnCounter)
 {
 	int			 n;
 	PGresult	*res;
@@ -5426,7 +5433,7 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 
 	for (int64_t i = start; i < start + base; i++)
 	{
-		init_row(con, i, base);
+		init_row(con, i, base, columnCounter);
 	}
 
 	res = PQgetResult(con);
@@ -5460,7 +5467,7 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
  * Wrapper for binary data load
  */
 static void
-initGenerateDataClientSideBinary(PGconn *con)
+initGenerateDataClientSideBinaryFrmt(PGconn *con)
 {
 
 	fprintf(stderr, "BINARY mode...\n");
@@ -5486,12 +5493,12 @@ initGenerateDataClientSideBinary(PGconn *con)
 		if (multi_xact)
 			executeStatement(con, "begin");
 
-		initPopulateTableBinary(con, "pgbench_branches", "bid, bbalance",
-								i, nbranches, initBranchBinary);
-		initPopulateTableBinary(con, "pgbench_tellers",  "tid, bid, tbalance",
-								i, ntellers,  initTellerBinary);
-		initPopulateTableBinary(con, "pgbench_accounts", "aid, bid, abalance",
-								i, naccounts, initAccountBinary);
+		initPopulateTableCopyBinary(con, "pgbench_branches", "bid, bbalance",
+									i, nbranches, initBranchBinary, 2);
+		initPopulateTableCopyBinary(con, "pgbench_tellers",  "tid, bid, tbalance",
+									i, ntellers,  initTellerBinary, 3);
+		initPopulateTableCopyBinary(con, "pgbench_accounts", "aid, bid, abalance",
+									i, naccounts, initAccountBinary, 3);
 
 		if (multi_xact)
 			executeStatement(con, "commit");
@@ -5515,10 +5522,10 @@ initGenerateDataClientSide(PGconn *con)
 	switch (data_generation_type)
 	{
 		case INIT_STEP_GEN_TYPE_COPY_TEXT:
-			initGenerateDataClientSideText(con);
+			initGenerateDataClientSideTextFrmt(con);
 			break;
 		case INIT_STEP_GEN_TYPE_COPY_BINARY:
-			initGenerateDataClientSideBinary(con);
+			initGenerateDataClientSideBinaryFrmt(con);
 			break;
 	}
 }
-- 
2.43.0

